#include <bits/stdc++.h>
#define int long long
using namespace std;
const int N = 1010;

//A TI SI BADBOY HOTSAUSE USNAMA ME LANSIRAS U KOSMOS


vector<int> graf[N];
bool mark[N];

void dfs(int v){
    mark[v]=true;
    for(int x : graf[v]){
         if(!mark[x])dfs(x);
    }

}

signed main()
{
    int n, q;
    cin >> n >> q;
    while(q--){
        int tr;
        cin >> tr;
        if(tr==1){
            int x, y;
            char a;
            cin >> x >> y >> a;
            if(a!='a')return 0;
            graf[x].push_back(y);
            graf[y].push_back(x);
        }
        else{
            for(int i=0; i <= n; i++)mark[i]=false;
            int x, y;
            cin >> x >> y;

            dfs(x);
            if(mark[y])cout<<1<<"\n";
            else cout<<0<<"\n";
            //markovace mi sva polja do kojih moze da se dodje do x

        }
    }

}